//VARIABLE TIMR CODE
#include <LiquidCrystal.h>
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 2;
const int potPin = 0;
const int buttonPin = 7;
const int buzzerPin = 13;
const int dismissPin = 8;
// const int pausePin = 10;
int state;
int minutes;
int seconds;
int timeStarted;
int timeTracking;
int timeLeft;
bool running;
int time;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

void setup() {
  // set up the LCD's number of columns and rows:
  Serial.begin(9600);
  lcd.begin(16, 2);
  pinMode(buttonPin,INPUT_PULLUP);
  pinMode(dismissPin,INPUT_PULLUP);
  // pinMode(pausePin,INPUT_PULLUP);
  pinMode(buzzerPin,OUTPUT);
  state = 0;
  running = true;
}

void loop() {
  while(running) {
  displayTimeLCD();
  if(digitalRead(buttonPin) == HIGH) {
    startTimerSequence();
  }
  Serial.println(seconds);
    while(state == 1) {
      while(minutes > -1) {    
      lcd.setCursor(0,0);
      lcd.print(minutes);
      lcd.setCursor(2,0);
      lcd.setCursor(1,0); //time display code min:sec
      lcd.print(":");
      timeLeft = seconds - ((millis()/1000)-timeStarted); 
      // above is: seconds in timer - seconds since timer started
      if(timeLeft<10) {//to display leading zeroes
        lcd.print("0");
        lcd.setCursor(3,0);
      }
      lcd.print(timeLeft); //prints to LCD & Serial to check accuracy
      Serial.println(timeLeft); //prints to LCD & Serial to check accuracy
      // if(digitalRead(pausePin) == HIGH)
      // {
      //   tone(buzzerPin,85,100);
      //   state = 2;
      //   break;
      // }
      if(timeLeft == 0) {
        minutes--;
        seconds = 59; 
        timeStarted = millis()/1000;
      }
    }
      timerFinished();
    }
    // while(state == 2)
    // {
    //   if(digitalRead(pausePin) == HIGH)
    //   {
    //     tone(buzzerPin,85,100);
    //     state = 1;
    //     break;
    //   }
    // }
  }
}
void timerFinished() {
    lcd.clear();
    lcd.setCursor(0,1);
    lcd.print("FINISHED");
    state=2;
    while(state==2) {
      for(int i=0;i<3;i++)
      {
        tone(buzzerPin,85,200);
        delay(500);
        if(digitalRead(dismissPin) == HIGH)
        {
          tone(buzzerPin,85,100);
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("TIMER RESET");
          delay(1000);
          lcd.clear();
          state=0;
          break;
        }
      }
      delay(500);
    }
    
}

void displayTimeLCD(){
  time = analogRead(potPin);
  time = map(time,1023,0,0,400);
  minutes = time/60;
  seconds = time%60;
  lcd.setCursor(0, 0); //time display code min:sec
  lcd.print(minutes); //time display code min:sec
  lcd.setCursor(1,0); //time display code min:sec
  lcd.print(":"); //time display code min:sec
  lcd.setCursor(2,0); //time display code min:sec
  if(seconds%5 ==0) //time display code min:sec
  { 
  lcd.print(seconds); //time display code min:sec
  } 
  lcd.setCursor(0,2);
  lcd.print("BEEK'S TIMER");
}

void startTimerSequence() {
  lcd.clear();
  tone(buzzerPin,85,100);
  lcd.setCursor(0,1);
  lcd.print("STARTED");
  seconds = ((seconds+2)/5)*5; //rounds time to nearest multiple of 5
  timeStarted = millis()/1000;
  state = 1;
}